package org.faktorips.tutorial.model.test;

import java.util.Map;

import javax.xml.parsers.ParserConfigurationException;

import org.faktorips.runtime.DefaultObjectReferenceStore;
import org.faktorips.runtime.DefaultReferenceResolver;
import org.faktorips.runtime.IModelObject;
import org.faktorips.runtime.IObjectReferenceStore;
import org.faktorips.runtime.internal.XmlCallback;
import org.faktorips.runtime.internal.XmlUtil;
import org.faktorips.runtime.test.IpsTestCase2;
import org.faktorips.runtime.test.IpsTestResult;
import org.faktorips.tutorial.model.hausrat.HausratVertrag;
import org.w3c.dom.Element;

/**
 * Instanzen dieser Klasse sind fachliche Testfaelle. Das Testen der fachlichen Logik findet in der
 * Methode executeAsserts() statt. Die Daten fuer die Testfaelle werden von FaktorIPS-Testfaellen
 * geliefert, die auf dem Testfalltyp basieren, auf dessen Basis auch diese Klasse generiert wird.
 *
 * @generated
 */
public class ErmittlungTarifzoneTest extends IpsTestCase2 {

    /**
     * @generated
     */
    public static final String TESTATTR_HAUSRAT_VERTRAG_TARIFZONE = "tarifzone";
    /**
     * @generated
     */
    private HausratVertrag inputHausratVertrag;
    /**
     * @generated
     */
    private HausratVertrag erwartetHausratVertrag;

    /**
     * Erzeugt eine neue Instanz des Testfalls.
     * 
     * @restrainedmodifiable
     */
    public ErmittlungTarifzoneTest(String qualifiedName) throws ParserConfigurationException {
        super(qualifiedName);
        // begin-user-code
        // end-user-code
    }

    /**
     * Fuehrt die zu testende Geschaeftslogik aus.
     *
     * @restrainedmodifiable
     */
    @Override
    /**
     */
    public void executeBusinessLogic() {
        // begin-user-code
        // nichts zu tun (die zu testende Logik wird durch getter-Aufruf ausgeführt)
        // end-user-code
    }

    /**
     * Fuehrt die Pruefungen (Asserts) aus, d.h. vergleicht die erwarteten Werten mit den
     * tatsaechlichen Ergebnissen.
     * <p>
     * Dies geschieht analog zu JUnit mit Aufrufen von assert(..) Methoden. Zum Beispiel
     * assertEquals(erwartetVertrag.getBeitrag(), inputVertrag.getBeitrag(), result);
     * 
     * Um das getestete Objekt bzw. das Attribut genauer zu beschreiben, kann zusaetzlich der Name
     * des getesteten Objektes und der Attributname uebergeben werden, bei der Ausfuehrung als
     * Faktor-Ips Testfall, wird dann im Fehlerfall das entsprechende Attribut-Feld im
     * Testfalleditor als rot gekennzeichnet. Der Name des Objektes bzw. der Name des Attributes,
     * muss gleich dem im Testfalltyp definierten Namen sein. Es muss immer der komplette Pfad zu
     * dem Testobjekt angegeben werden, wobei die einzelnen Testobjekte auf den unterschiedlichen
     * Ebenen (Root/Parent/Child) durch "." getrennt werden muessen. Wenn im Testfall mehrere
     * Instanzen des gleiche Testobjektes vorhanden sind, muss ein Index an den Namen (getrennt
     * durch "#") angefuegt werden. Beispiel: assertEquals(erwartetVertrag.getBeitrag(),
     * inputVertrag.getBeitrag(), result, "Police#0.Vertrag#0", "beitrag");
     *
     * @restrainedmodifiable
     */
    @Override
    /**
     */
    public void executeAsserts(IpsTestResult result) {
        // begin-user-code
        String erwartetTarifzone = (String)getExtensionAttributeValue(
                erwartetHausratVertrag, TESTATTR_HAUSRAT_VERTRAG_TARIFZONE);

        String inputTarifzone = inputHausratVertrag.getTarifzone();
        assertEquals(erwartetTarifzone, inputTarifzone, result, "HausratVertrag", TESTATTR_HAUSRAT_VERTRAG_TARIFZONE);
        // end-user-code
    }

    /**
     * Initialisiert die Eingabewerte aus dem XML.
     *
     * @restrainedmodifiable
     */
    @Override
    /**
     */
    public void initInputFromXml(Element element) {
        // begin-user-code
        // end-user-code
        IObjectReferenceStore objectReferenceStore = new DefaultObjectReferenceStore();
        Element childElement = null;
        HausratVertragXmlCallback hausratVertragXmlCallback = new HausratVertragXmlCallback(
                true);
        childElement = XmlUtil.getFirstElement(element, "HausratVertrag");
        if (childElement != null) {
            try {
                String className = childElement.getAttribute("class");
                inputHausratVertrag = (HausratVertrag)Class
                        .forName(className, true, HausratVertrag.class.getClassLoader()).getConstructor().newInstance();
                inputHausratVertrag.initFromXml(childElement, true, getRepository(), objectReferenceStore,
                        hausratVertragXmlCallback);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        try {
            new DefaultReferenceResolver().resolve(objectReferenceStore);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * Initialisiert die erwarteten Werte aus dem XML.
     *
     * @restrainedmodifiable
     */
    @Override
    /**
     */
    public void initExpectedResultFromXml(Element element) {
        // begin-user-code
        // end-user-code
        IObjectReferenceStore objectReferenceStore = new DefaultObjectReferenceStore();
        Element childElement = null;
        HausratVertragXmlCallback hausratVertragXmlCallback = new HausratVertragXmlCallback(
                false);
        childElement = XmlUtil.getFirstElement(element, "HausratVertrag");
        if (childElement != null) {
            try {
                String className = childElement.getAttribute("class");
                erwartetHausratVertrag = (HausratVertrag)Class
                        .forName(className, true, HausratVertrag.class.getClassLoader()).getConstructor().newInstance();
                erwartetHausratVertrag.initFromXml(childElement, true, getRepository(), objectReferenceStore,
                        hausratVertragXmlCallback);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        try {
            new DefaultReferenceResolver().resolve(objectReferenceStore);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * XMLCallback Klasse fuer den Testparameter HausratVertrag.
     *
     * @generated
     */
    private class HausratVertragXmlCallback implements XmlCallback {
        /**
         * Gibt an ob die Klasse fuer die Input (<code>true</code>) oder fuer die erwarteten Werte
         * (<code>false</code>) verwendet wird.
         *
         * @generated
         */
        private boolean input;

        /**
         * Erzeugt eine neue XMLCallback Klasse fuer den Testparameter HausratVertrag.
         *
         * @generated
         */
        public HausratVertragXmlCallback(boolean input) {
            this.input = input;
        }

        /**
         * {@inheritDoc}
         *
         * @generated
         */
        @Override
        public void initProperties(String pathFromAggregateRoot,
                IModelObject modelObject,
                Map<String, String> propMap) {
            if (pathFromAggregateRoot.equals("/HausratVertrag")) {
                String value = null;
                if (!input) {
                    value = propMap.get(TESTATTR_HAUSRAT_VERTRAG_TARIFZONE);
                    addExtensionAttribute(modelObject, TESTATTR_HAUSRAT_VERTRAG_TARIFZONE, value);
                }
            }
        }

    }

}
